/*
  L3D20 Driver_source
*/
#include"L3GD20_Driver.h"
extern sfr sbit GYRO_CS;
extern sfr sbit GYRO_CS_Dir;

extern sfr sbit DATA_RDY;
extern sfr sbit DATA_RDY_Dir;

extern sfr sbit GYRO_INT;
extern sfr sbit GYRO_INT_Dir;

extern int X_AXI;
extern int Y_AXI;
extern int Z_AXI;

unsigned short L3GD20_ReadReg(unsigned short address, unsigned short *dat){
  I2C1_Start();              // issue I2C start signal
  I2C1_Wr(L3GD20_W_ADDRESS); // send byte via I2C (device address + W)
  I2C1_Wr(address);          // send byte (data address)

  I2C1_Repeated_Start();     // issue I2C signal repeated start
  I2C1_Wr(L3GD20_R_ADDRESS); // send byte (device address + R)
  *dat = I2C1_Rd(0);         // Read the data (NO acknowledge)
  I2C1_Stop();               // issue I2C stop signal
  return 1;
}

unsigned short L3GD20_WriteReg(unsigned short address, unsigned short dat){
  I2C1_Start();              // issue I2C start signal
  I2C1_Wr(L3GD20_W_ADDRESS); // send byte via I2C  (device address + W)
  I2C1_Wr(address);          // send byte (address of the location)
  I2C1_Wr(dat);              // send data (data to be written)
  I2C1_Stop();               // issue I2C stop signal*/
  return 1;
}

unsigned short Gyro_Init(){
unsigned short val;
  GYRO_CS = 1;
  GYRO_CS_Dir = 0;
  DATA_RDY_Dir = 1;
  GYRO_INT_Dir = 1;
  return 1;
}

unsigned short Identify_Gyro(){
unsigned short val;
char txt[3];
  if (L3GD20_ReadReg(L3GD20_WHO_AM_I, val) != 1 )
    return 0;
  return val;
}

unsigned short L3GD20_Configure(unsigned char address, unsigned short config){
char value;
  if( !L3GD20_ReadReg(L3GD20_CTRL_REG5, &value) )
    return 0;
  if( !L3GD20_WriteReg(address, config) )
    return 0;
  return 1;
}

unsigned short L3GD20_GetAngRateRaw(GData *buff){
  char low_byte;
  char high_byte;
  
  while(!DATA_RDY){};
  if( !L3GD20_ReadReg(L3GD20_OUT_X_L, &low_byte) )  // Read the LBs from X axis output register
      return 0;
  if( !L3GD20_ReadReg(L3GD20_OUT_X_H, &high_byte) ) // Read the LBs from X axis output register
      return 0;
  buff->X_AXIS = ( (high_byte << 8) | low_byte );   // Create int from two bytes
  while(!DATA_RDY){};
  if( !L3GD20_ReadReg(L3GD20_OUT_Y_L, &low_byte) )  // Read the LBs from Y axis output register
      return 0;
  if( !L3GD20_ReadReg(L3GD20_OUT_Y_H, &high_byte) ) // Read the LBs from Y axis output register
      return 0;
  buff->Y_AXIS = ( (high_byte << 8) | low_byte );   // Create int from two bytes
  while(!DATA_RDY){};
  if( !L3GD20_ReadReg(L3GD20_OUT_Z_L, &low_byte) )  // Read the LBs from Z axis output register
      return 0;
  if( !L3GD20_ReadReg(L3GD20_OUT_Z_H, &high_byte) ) // Read the LBs from Z axis output register
      return 0;
  buff->Z_AXIS = ( (high_byte << 8) | low_byte );   // Create int from two bytes

  return 1;
}